- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
BlisBranchObjectInt Class Reference

`#include <BlisBranchObjectInt.h>`

Inheritance diagram for BlisBranchObjectInt:
[legend]
Collaboration diagram for BlisBranchObjectInt:
[legend]

## Public Member Functions
| BlisBranchObjectInt ()
| Default constructor. More...
| BlisBranchObjectInt (BlisModel *model, int varInd, int direction, double value)
| Construct a branching object, which branching on variable varInd. More...
| BlisBranchObjectInt (BlisModel *model, int varInd, int intScore, double dblScore, int direction, double value)
| Construct a branching object, which branching on variable varInd. More...
| BlisBranchObjectInt (BlisModel *model, int varInd, int direction, double lowerValue, double upperValue)
| Create a degenerate branching object. More...
| BlisBranchObjectInt (const BlisBranchObjectInt &)
| Copy constructor. More...
BlisBranchObjectInt & | operator= (const BlisBranchObjectInt &rhs)
| Assignment operator. More...
virtual BcpsBranchObject * | clone () const
| Clone. More...
virtual | ~BlisBranchObjectInt ()
| Destructor. More...
virtual double | branch (bool normalBranch=false)
| Set the bounds for the variable according to the current arm of the branch and advances the object state to the next arm. More...
virtual void | print (bool normalBranch)
| Print something about branch - only if log level high. More...
const double * | getDown () const
| Get down arm bounds. More...
const double * | getUp () const
| Get upper arm bounds. More...
virtual AlpsReturnStatus | encode (AlpsEncoded *encoded) const
| Pack to an encoded object. More...
virtual AlpsReturnStatus | decode (AlpsEncoded &encoded)
| Unpack a branching object from an encoded object. More...
| BlisBranchObjectInt ()
| Default constructor. More...
| BlisBranchObjectInt (BlisModel *model, int varInd, int direction, double value)
| Construct a branching object, which branching on variable varInd. More...
| BlisBranchObjectInt (BlisModel *model, int varInd, int intScore, double dblScore, int direction, double value)
| Construct a branching object, which branching on variable varInd. More...
| BlisBranchObjectInt (BlisModel *model, int varInd, int direction, double lowerValue, double upperValue)
| Create a degenerate branching object. More...
| BlisBranchObjectInt (const BlisBranchObjectInt &)
| Copy constructor. More...
BlisBranchObjectInt & | operator= (const BlisBranchObjectInt &rhs)
| Assignment operator. More...
virtual BcpsBranchObject * | clone () const
| Clone. More...
virtual | ~BlisBranchObjectInt ()
| Destructor. More...
virtual double | branch (bool normalBranch=false)
| Set the bounds for the variable according to the current arm of the branch and advances the object state to the next arm. More...
virtual void | print (bool normalBranch)
| Print something about branch - only if log level high. More...
const double * | getDown () const
| Get down arm bounds. More...
const double * | getUp () const
| Get upper arm bounds. More...
virtual AlpsReturnStatus | encode (AlpsEncoded *encoded) const
| Pack to an encoded object. More...
virtual AlpsReturnStatus | decode (AlpsEncoded &encoded)
| Unpack a branching object from an encoded object. More...
Public Member Functions inherited from BcpsBranchObject
| BcpsBranchObject ()
| Default Constructor. More...
| BcpsBranchObject (BcpsModel *model)
| Useful constructor. More...
| BcpsBranchObject (BcpsModel *model, int objectIndex, int direction, double value)
| Useful constructor. More...
| BcpsBranchObject (BcpsModel *model, int objectIndex, int upScore, double downScore, int direction, double value)
| Useful constructor. More...
| BcpsBranchObject (const BcpsBranchObject &)
| Copy constructor. More...
virtual | ~BcpsBranchObject ()
| Destructor. More...
BcpsBranchObject & | operator= (const BcpsBranchObject &rhs)
| Assignment operator. More...
int | getType ()
| Get type. More...
void | setType (int t)
| Set type. More...
virtual int | numBranches () const
| The number of branch arms created for this branch object. More...
virtual int | numBranchesLeft () const
| The number of branch arms left to be evaluated. More...
virtual bool | boundBranch () const
| Return true if branching should fix object bounds. More...
int | getObjectIndex () const
| Object objectIndex. More...
void | setObjectIndex (int ind)
| Set object objectIndex. More...
double | getUpScore () const
| Get integer score. More...
void | setUpScore (double score)
| Set integer score. More...
double | getDownScore () const
| Get double score. More...
void | setDownScore (double score)
| Get double score. More...
int | getDirection () const
| Returns a code indicating the active arm of the branching object. More...
void | setDirection (int direction)
| Set the direction of the branching object. More...
double | getValue () const
| Return object branching value. More...
BcpsModel * | model () const
| Return model. More...

## Protected Member Functions
AlpsReturnStatus | encodeBlis (AlpsEncoded *encoded) const
| Pack Blis portion to an encoded object. More...
AlpsReturnStatus | decodeBlis (AlpsEncoded &encoded)
| Unpack Blis portion from an encoded object. More...
AlpsReturnStatus | encodeBlis (AlpsEncoded *encoded) const
| Pack Blis portion to an encoded object. More...
AlpsReturnStatus | decodeBlis (AlpsEncoded &encoded)
| Unpack Blis portion from an encoded object. More...
Protected Member Functions inherited from BcpsBranchObject
AlpsReturnStatus | encodeBcps (AlpsEncoded *encoded) const
| Pack Bcps portion to an encoded object. More...
AlpsReturnStatus | decodeBcps (AlpsEncoded &encoded)
| Unpack Bcps portion from an encoded object. More...

## Protected Attributes
double | down_ [2]
| Down_[0]: the lower bound of down arm; Down_[1]: the upper bound of down arm;. More...
double | up_ [2]
| Up_[0]: the lower bound of upper arm; Up_[1]: the upper bound of upper arm;. More...
Protected Attributes inherited from BcpsBranchObject
int | type_
| Type of branching. More...
BcpsModel * | model_
| The model that owns this branch object. More...
int | objectIndex_
| Branch object index. More...
double | upScore_
| Quality/Goodness of this object. More...
double | downScore_
| The score of branching down. More...
int | direction_
| Information required to do branching. More...
double | value_
| Current branching value. More...
int | numBranchesLeft_
| Number of arms remaining to be evaluated. More...

## Detailed Description

Definition at line 38 of file BlisBranchObjectInt.h.

## Constructor & Destructor Documentation

BlisBranchObjectInt::BlisBranchObjectInt | ( |  | ) |
| inline

Default constructor.

Definition at line 53 of file BlisBranchObjectInt.h.

BlisBranchObjectInt::BlisBranchObjectInt | ( | BlisModel * | model,
|  | int | varInd,
|  | int | direction,
|  | double | value
| ) |  |
| inline

Construct a branching object, which branching on variable varInd.

Parameters

  varInd | the index of integer variable in object set
  direction | the direction of first branching: 1(up), -1(down)
  value | the fractional solution value of variable varInd

Definition at line 69 of file BlisBranchObjectInt.h.

BlisBranchObjectInt::BlisBranchObjectInt | ( | BlisModel * | model,
|  | int | varInd,
|  | int | intScore,
|  | double | dblScore,
|  | int | direction,
|  | double | value
| ) |  |
| inline

Construct a branching object, which branching on variable varInd.

Parameters

  varInd | the index of integer variable in object set
  intScore | the integer score/goodness
  dblScore | the double score/goodness
  direction | the direction of first branching: 1(up), -1(down)
  value | the fractional solution value of variable varInd

Definition at line 91 of file BlisBranchObjectInt.h.

BlisBranchObjectInt::BlisBranchObjectInt | ( | BlisModel * | model,
|  | int | varInd,
|  | int | direction,
|  | double | lowerValue,
|  | double | upperValue
| ) |  |
| inline

Create a degenerate branching object.

Specifies a `one-direction branch'. Calling branch() for this object will always result in lowerValue <= x <= upperValue. Used to fix a variable when lowerValue = upperValue.

Definition at line 113 of file BlisBranchObjectInt.h.

BlisBranchObjectInt::BlisBranchObjectInt | ( | const BlisBranchObjectInt & |  | ) |

Copy constructor.

virtual BlisBranchObjectInt::~BlisBranchObjectInt | ( |  | ) |
| inline virtual

Destructor.

Definition at line 141 of file BlisBranchObjectInt.h.

BlisBranchObjectInt::BlisBranchObjectInt | ( |  | ) |
| inline

Default constructor.

Definition at line 53 of file BlisBranchObjectInt.h.

BlisBranchObjectInt::BlisBranchObjectInt | ( | BlisModel * | model,
|  | int | varInd,
|  | int | direction,
|  | double | value
| ) |  |
| inline

Construct a branching object, which branching on variable varInd.

Parameters

  varInd | the index of integer variable in object set
  direction | the direction of first branching: 1(up), -1(down)
  value | the fractional solution value of variable varInd

Definition at line 69 of file BlisBranchObjectInt.h.

BlisBranchObjectInt::BlisBranchObjectInt | ( | BlisModel * | model,
|  | int | varInd,
|  | int | intScore,
|  | double | dblScore,
|  | int | direction,
|  | double | value
| ) |  |
| inline

Construct a branching object, which branching on variable varInd.

Parameters

  varInd | the index of integer variable in object set
  intScore | the integer score/goodness
  dblScore | the double score/goodness
  direction | the direction of first branching: 1(up), -1(down)
  value | the fractional solution value of variable varInd

Definition at line 91 of file BlisBranchObjectInt.h.

BlisBranchObjectInt::BlisBranchObjectInt | ( | BlisModel * | model,
|  | int | varInd,
|  | int | direction,
|  | double | lowerValue,
|  | double | upperValue
| ) |  |
| inline

Create a degenerate branching object.

Specifies a `one-direction branch'. Calling branch() for this object will always result in lowerValue <= x <= upperValue. Used to fix a variable when lowerValue = upperValue.

Definition at line 113 of file BlisBranchObjectInt.h.

BlisBranchObjectInt::BlisBranchObjectInt | ( | const BlisBranchObjectInt & |  | ) |

Copy constructor.

virtual BlisBranchObjectInt::~BlisBranchObjectInt | ( |  | ) |
| inline virtual

Destructor.

Definition at line 141 of file BlisBranchObjectInt.h.

## Member Function Documentation

BlisBranchObjectInt& BlisBranchObjectInt::operator= | ( | const BlisBranchObjectInt & | rhs | ) |

Assignment operator.

virtual BcpsBranchObject* BlisBranchObjectInt::clone | ( |  | ) | const
| inline virtual

Clone.

Implements BcpsBranchObject.

Definition at line 136 of file BlisBranchObjectInt.h.

virtual double BlisBranchObjectInt::branch | ( | bool | normalBranch = `false` | ) |
| virtual

Set the bounds for the variable according to the current arm of the branch and advances the object state to the next arm.

Returns change in guessed objective on next branch.

Implements BcpsBranchObject.

virtual void BlisBranchObjectInt::print | ( | bool | normalBranch | ) |
| virtual

Print something about branch - only if log level high.

Reimplemented from BcpsBranchObject.

const double* BlisBranchObjectInt::getDown | ( |  | ) | const
| inline

Get down arm bounds.

Definition at line 152 of file BlisBranchObjectInt.h.

const double* BlisBranchObjectInt::getUp | ( |  | ) | const
| inline

Get upper arm bounds.

Definition at line 155 of file BlisBranchObjectInt.h.

AlpsReturnStatus BlisBranchObjectInt::encodeBlis | ( | AlpsEncoded * | encoded | ) | const
| inline protected

Pack Blis portion to an encoded object.

Definition at line 160 of file BlisBranchObjectInt.h.

AlpsReturnStatus BlisBranchObjectInt::decodeBlis | ( | AlpsEncoded & | encoded | ) |
| inline protected

Unpack Blis portion from an encoded object.

Definition at line 176 of file BlisBranchObjectInt.h.

virtual AlpsReturnStatus BlisBranchObjectInt::encode | ( | AlpsEncoded * | encoded | ) | const
| inline virtual

Pack to an encoded object.

Reimplemented from BcpsBranchObject.

Definition at line 193 of file BlisBranchObjectInt.h.

virtual AlpsReturnStatus BlisBranchObjectInt::decode | ( | AlpsEncoded & | encoded | ) |
| inline virtual

Unpack a branching object from an encoded object.

Reimplemented from BcpsBranchObject.

Definition at line 203 of file BlisBranchObjectInt.h.

BlisBranchObjectInt& BlisBranchObjectInt::operator= | ( | const BlisBranchObjectInt & | rhs | ) |

Assignment operator.

virtual BcpsBranchObject* BlisBranchObjectInt::clone | ( |  | ) | const
| inline virtual

Clone.

Implements BcpsBranchObject.

Definition at line 136 of file BlisBranchObjectInt.h.

virtual double BlisBranchObjectInt::branch | ( | bool | normalBranch = `false` | ) |
| virtual

Set the bounds for the variable according to the current arm of the branch and advances the object state to the next arm.

Returns change in guessed objective on next branch.

Implements BcpsBranchObject.

virtual void BlisBranchObjectInt::print | ( | bool | normalBranch | ) |
| virtual

Print something about branch - only if log level high.

Reimplemented from BcpsBranchObject.

const double* BlisBranchObjectInt::getDown | ( |  | ) | const
| inline

Get down arm bounds.

Definition at line 152 of file BlisBranchObjectInt.h.

const double* BlisBranchObjectInt::getUp | ( |  | ) | const
| inline

Get upper arm bounds.

Definition at line 155 of file BlisBranchObjectInt.h.

AlpsReturnStatus BlisBranchObjectInt::encodeBlis | ( | AlpsEncoded * | encoded | ) | const
| inline protected

Pack Blis portion to an encoded object.

Definition at line 160 of file BlisBranchObjectInt.h.

AlpsReturnStatus BlisBranchObjectInt::decodeBlis | ( | AlpsEncoded & | encoded | ) |
| inline protected

Unpack Blis portion from an encoded object.

Definition at line 176 of file BlisBranchObjectInt.h.

virtual AlpsReturnStatus BlisBranchObjectInt::encode | ( | AlpsEncoded * | encoded | ) | const
| inline virtual

Pack to an encoded object.

Reimplemented from BcpsBranchObject.

Definition at line 193 of file BlisBranchObjectInt.h.

virtual AlpsReturnStatus BlisBranchObjectInt::decode | ( | AlpsEncoded & | encoded | ) |
| inline virtual

Unpack a branching object from an encoded object.

Reimplemented from BcpsBranchObject.

Definition at line 203 of file BlisBranchObjectInt.h.

## Member Data Documentation

double BlisBranchObjectInt::down_
| protected

Down_[0]: the lower bound of down arm; Down_[1]: the upper bound of down arm;.

Definition at line 44 of file BlisBranchObjectInt.h.

double BlisBranchObjectInt::up_
| protected

Up_[0]: the lower bound of upper arm; Up_[1]: the upper bound of upper arm;.

Definition at line 48 of file BlisBranchObjectInt.h.

The documentation for this class was generated from the following files:

- /tmp/CHiPPS-Blis-0.94.3/Bcps/examples/Blis/BlisBranchObjectInt.h
- /tmp/CHiPPS-Blis-0.94.3/Blis/src/BlisBranchObjectInt.h